---
title: Create postmortem template
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Incidents
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create postmortem template{% #create-postmortem-template %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                    |
| ----------------- | ------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/incidents/config/postmortem-templates |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/incidents/config/postmortem-templates |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/incidents/config/postmortem-templates      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/incidents/config/postmortem-templates      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/incidents/config/postmortem-templates  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/incidents/config/postmortem-templates |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/incidents/config/postmortem-templates     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/incidents/config/postmortem-templates |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/incidents/config/postmortem-templates |

### Overview

Create a new postmortem template for incidents.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field                    | Field                              | Type      | Description                                                                                                                                                                 |
| ------------------------------- | ---------------------------------- | --------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                                 | data [*required*]             | object    | Data object for creating or updating a postmortem template.                                                                                                                 |
| data                            | attributes [*required*]       | object    | Attributes for creating or updating a postmortem template.                                                                                                                  |
| attributes                      | confluence_postmortem_settings     | object    | Settings for a postmortem template stored in Confluence. Required when `location` is `confluence`.                                                                          |
| confluence_postmortem_settings  | account_id [*required*]       | string    | The ID of the Confluence integration account.                                                                                                                               |
| confluence_postmortem_settings  | parent_id                          | string    | The ID of the parent Confluence page under which postmortems are created.                                                                                                   |
| confluence_postmortem_settings  | space_id [*required*]         | string    | The ID of the Confluence space where postmortems are created.                                                                                                               |
| attributes                      | content                            | string    | The templated content of the postmortem, supporting Markdown and incident template variables.                                                                               |
| attributes                      | google_docs_postmortem_settings    | object    | Settings for a postmortem template stored in Google Docs. Required when `location` is `google_docs`.                                                                        |
| google_docs_postmortem_settings | account_id [*required*]       | string    | The ID of the Google Drive integration account.                                                                                                                             |
| google_docs_postmortem_settings | parent_folder_id [*required*] | string    | The ID of the Google Drive folder where postmortems are created.                                                                                                            |
| attributes                      | is_default                         | date-time | When set, marks this template as a default. The effective default for an incident type is the template with the most recent `is_default` timestamp. Set to `null` to unset. |
| attributes                      | location                           | enum      | The location where the postmortem is created and stored. Allowed enum values: `datadog_notebooks,confluence,google_docs`                                                    |
| attributes                      | name [*required*]             | string    | The name of the template.                                                                                                                                                   |
| data                            | id                                 | string    | The ID of the template. Required when updating.                                                                                                                             |
| data                            | relationships                      | object    | Relationships for a postmortem template. `incident_type` is required when creating a template and is immutable afterwards.                                                  |
| relationships                   | incident_type                      | object    | Relationship to the incident type this template belongs to.                                                                                                                 |
| incident_type                   | data [*required*]             | object    | Incident type relationship data.                                                                                                                                            |
| data                            | id [*required*]               | uuid      | The incident type identifier.                                                                                                                                               |
| data                            | type [*required*]             | string    | The incident type resource type.                                                                                                                                            |
| data                            | type [*required*]             | enum      | Postmortem template resource type. Allowed enum values: `postmortem_templates,postmortem_template`                                                                          |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "confluence_postmortem_settings": {
        "account_id": "123456",
        "parent_id": "345678",
        "space_id": "789012"
      },
      "content": "# Overview\n\n# What Happened\n\n# Timeline\n\n# Action Items",
      "google_docs_postmortem_settings": {
        "account_id": "123456",
        "parent_folder_id": "789012"
      },
      "is_default": "2024-01-01T00:00:00+00:00",
      "location": "datadog_notebooks",
      "name": "Standard Postmortem Template"
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "relationships": {
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000009",
          "type": "incident_types"
        }
      }
    },
    "type": "postmortem_templates"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response containing a single postmortem template.

| Parent field                    | Field                              | Type      | Description                                                                                                                                         |
| ------------------------------- | ---------------------------------- | --------- | --------------------------------------------------------------------------------------------------------------------------------------------------- |
|                                 | data [*required*]             | object    | Data object for a postmortem template returned in a response.                                                                                       |
| data                            | attributes [*required*]       | object    | Attributes of a postmortem template returned in a response.                                                                                         |
| attributes                      | confluence_postmortem_settings     | object    | Settings for a postmortem template stored in Confluence. Required when `location` is `confluence`.                                                  |
| confluence_postmortem_settings  | account_id [*required*]       | string    | The ID of the Confluence integration account.                                                                                                       |
| confluence_postmortem_settings  | parent_id                          | string    | The ID of the parent Confluence page under which postmortems are created.                                                                           |
| confluence_postmortem_settings  | space_id [*required*]         | string    | The ID of the Confluence space where postmortems are created.                                                                                       |
| attributes                      | content [*required*]          | string    | The templated content of the postmortem, supporting Markdown and incident template variables.                                                       |
| attributes                      | createdAt [*required*]        | date-time | When the template was created.                                                                                                                      |
| attributes                      | google_docs_postmortem_settings    | object    | Settings for a postmortem template stored in Google Docs. Required when `location` is `google_docs`.                                                |
| google_docs_postmortem_settings | account_id [*required*]       | string    | The ID of the Google Drive integration account.                                                                                                     |
| google_docs_postmortem_settings | parent_folder_id [*required*] | string    | The ID of the Google Drive folder where postmortems are created.                                                                                    |
| attributes                      | is_default [*required*]       | date-time | When set, marks this template as a default. The effective default for an incident type is the template with the most recent `is_default` timestamp. |
| attributes                      | location [*required*]         | enum      | The location where the postmortem is created and stored. Allowed enum values: `datadog_notebooks,confluence,google_docs`                            |
| attributes                      | modifiedAt [*required*]       | date-time | When the template was last modified.                                                                                                                |
| attributes                      | name [*required*]             | string    | The name of the template.                                                                                                                           |
| data                            | id [*required*]               | string    | The ID of the template.                                                                                                                             |
| data                            | relationships                      | object    | Relationships of a postmortem template returned in a response.                                                                                      |
| relationships                   | incident_type                      | object    | Relationship to the incident type this template belongs to.                                                                                         |
| incident_type                   | data [*required*]             | object    | Incident type relationship data.                                                                                                                    |
| data                            | id [*required*]               | uuid      | The incident type identifier.                                                                                                                       |
| data                            | type [*required*]             | string    | The incident type resource type.                                                                                                                    |
| relationships                   | last_modified_by_user              | object    | Relationship to a user.                                                                                                                             |
| last_modified_by_user           | data [*required*]             | object    | User relationship data.                                                                                                                             |
| data                            | id [*required*]               | uuid      | The user identifier.                                                                                                                                |
| data                            | type [*required*]             | string    | The user resource type.                                                                                                                             |
| data                            | type [*required*]             | enum      | Postmortem template resource type. Allowed enum values: `postmortem_templates,postmortem_template`                                                  |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "confluence_postmortem_settings": {
        "account_id": "123456",
        "parent_id": "345678",
        "space_id": "789012"
      },
      "content": "# Overview\n\n# What Happened\n\n# Timeline\n\n# Action Items",
      "createdAt": "2026-01-13T17:15:53.208340Z",
      "google_docs_postmortem_settings": {
        "account_id": "123456",
        "parent_folder_id": "789012"
      },
      "is_default": "2024-01-01T00:00:00+00:00",
      "location": "datadog_notebooks",
      "modifiedAt": "2026-01-13T17:15:53.208340Z",
      "name": "Standard Postmortem Template"
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "relationships": {
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000009",
          "type": "incident_types"
        }
      },
      "last_modified_by_user": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "users"
        }
      }
    },
    "type": "postmortem_templates"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/incidents/config/postmortem-templates" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "content": "# Overview\n\n# What Happened\n\n# Timeline\n\n# Action Items",
      "name": "Standard Postmortem Template"
    },
    "relationships": {
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000009",
          "type": "incident_types"
        }
      }
    },
    "type": "postmortem_templates"
  }
}
EOF 
                
##### 

```python
"""
Create postmortem template returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.incidents_api import IncidentsApi
from datadog_api_client.v2.model.postmortem_template_attributes_request import PostmortemTemplateAttributesRequest
from datadog_api_client.v2.model.postmortem_template_data_request import PostmortemTemplateDataRequest
from datadog_api_client.v2.model.postmortem_template_request import PostmortemTemplateRequest
from datadog_api_client.v2.model.postmortem_template_type import PostmortemTemplateType

body = PostmortemTemplateRequest(
    data=PostmortemTemplateDataRequest(
        attributes=PostmortemTemplateAttributesRequest(
            name="Standard Postmortem Template",
        ),
        type=PostmortemTemplateType.POSTMORTEM_TEMPLATE,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_incident_postmortem_template"] = True
with ApiClient(configuration) as api_client:
    api_instance = IncidentsApi(api_client)
    response = api_instance.create_incident_postmortem_template(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Create postmortem template returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_incident_postmortem_template".to_sym] = true
end
api_instance = DatadogAPIClient::V2::IncidentsAPI.new

body = DatadogAPIClient::V2::PostmortemTemplateRequest.new({
  data: DatadogAPIClient::V2::PostmortemTemplateDataRequest.new({
    attributes: DatadogAPIClient::V2::PostmortemTemplateAttributesRequest.new({
      name: "Standard Postmortem Template",
    }),
    type: DatadogAPIClient::V2::PostmortemTemplateType::POSTMORTEM_TEMPLATE,
  }),
})
p api_instance.create_incident_postmortem_template(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Create postmortem template returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.PostmortemTemplateRequest{
		Data: datadogV2.PostmortemTemplateDataRequest{
			Attributes: datadogV2.PostmortemTemplateAttributesRequest{
				Name: "Standard Postmortem Template",
			},
			Type: datadogV2.POSTMORTEMTEMPLATETYPE_POSTMORTEM_TEMPLATE,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateIncidentPostmortemTemplate", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewIncidentsApi(apiClient)
	resp, r, err := api.CreateIncidentPostmortemTemplate(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `IncidentsApi.CreateIncidentPostmortemTemplate`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `IncidentsApi.CreateIncidentPostmortemTemplate`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Create postmortem template returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.IncidentsApi;
import com.datadog.api.client.v2.model.PostmortemTemplateAttributesRequest;
import com.datadog.api.client.v2.model.PostmortemTemplateDataRequest;
import com.datadog.api.client.v2.model.PostmortemTemplateRequest;
import com.datadog.api.client.v2.model.PostmortemTemplateResponse;
import com.datadog.api.client.v2.model.PostmortemTemplateType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createIncidentPostmortemTemplate", true);
    IncidentsApi apiInstance = new IncidentsApi(defaultClient);

    PostmortemTemplateRequest body =
        new PostmortemTemplateRequest()
            .data(
                new PostmortemTemplateDataRequest()
                    .attributes(
                        new PostmortemTemplateAttributesRequest()
                            .name("Standard Postmortem Template"))
                    .type(PostmortemTemplateType.POSTMORTEM_TEMPLATE));

    try {
      PostmortemTemplateResponse result = apiInstance.createIncidentPostmortemTemplate(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling IncidentsApi#createIncidentPostmortemTemplate");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Create postmortem template returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_incidents::IncidentsAPI;
use datadog_api_client::datadogV2::model::PostmortemTemplateAttributesRequest;
use datadog_api_client::datadogV2::model::PostmortemTemplateDataRequest;
use datadog_api_client::datadogV2::model::PostmortemTemplateRequest;
use datadog_api_client::datadogV2::model::PostmortemTemplateType;

#[tokio::main]
async fn main() {
    let body = PostmortemTemplateRequest::new(PostmortemTemplateDataRequest::new(
        PostmortemTemplateAttributesRequest::new("Standard Postmortem Template".to_string()),
        PostmortemTemplateType::POSTMORTEM_TEMPLATE,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateIncidentPostmortemTemplate", true);
    let api = IncidentsAPI::with_config(configuration);
    let resp = api.create_incident_postmortem_template(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Create postmortem template returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createIncidentPostmortemTemplate"] = true;
const apiInstance = new v2.IncidentsApi(configuration);

const params: v2.IncidentsApiCreateIncidentPostmortemTemplateRequest = {
  body: {
    data: {
      attributes: {
        name: "Standard Postmortem Template",
      },
      type: "postmortem_template",
    },
  },
};

apiInstance
  .createIncidentPostmortemTemplate(params)
  .then((data: v2.PostmortemTemplateResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
